require 'datatables_server_side'
describe DatatablesServerSide::Datatables do
  def dummy_table
    context = double(:render => "some content...", :link_to => "<a href='www.somewhere.com'>somewhere</a>") #TODO improve this stub
    DatatablesServerSide::Datatables.new(context)
  end

# checks each element inside array to be html_safe
  def are_elements_safe?(data)
    is_valid=true
    data.each do |array_value|
      if array_value.class==Array
        is_valid= is_valid && are_elements_safe?(array_value)
      elsif array_value.class!=NilClass
        is_valid= is_valid && array_value.html_safe?
      end
    end
    return is_valid
  end

  def dummy_data
    array_of_text = Array.new
    data=Array.new
    array_of_text[0]="teste"
    array_of_text[1]="teste"
    array_of_text[2]="<a>teste</a>"
    data[0]="teste"
    data[1]=array_of_text
    data
  end

  it 'initializes' do
    my_table=dummy_table
    my_table.class.should eq(DatatablesServerSide::Datatables)
  end


  it 'protects records with html safe' do
    my_table=dummy_table
    safe_records=my_table.send(:safe_attributes, dummy_data)
    are_elements_safe?(safe_records).should eq true
  end


  it 'gets the correct page' do
    my_table=dummy_table
    my_table.stub(:per_page){10}
    my_table.stub(:params){{iDisplayStart: nil}}
    my_table.send(:page).should eq 1
    my_table.stub(:params){{iDisplayStart: 2}}
    my_table.send(:page).should eq 1
    my_table.stub(:params){{iDisplayStart: 10}}
    my_table.send(:page).should eq 2
  end


  it 'have default per page of 10' do
    my_table=dummy_table
    my_table.stub(:params){{iDisplayLength: nil}}
    my_table.send(:per_page).should eq 10
  end


  it 'have default sor direction of asc' do
    my_table=dummy_table
    my_table.stub(:params){{sSortDir_0: nil}}
    my_table.send(:sort_direction).should eq 'asc'
  end

end
